using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.IO;
using System.Data;
using System.Xml;

namespace BYOJeopardy_net
{
    public class JData
    {
        public ArrayList topics = new ArrayList();
        public JData()
        {
        }
        public bool OpenFile_as_not_XML(string FileName)
        {
            try
            {
                topics.Clear();
                //Open File
                StreamReader JeopardyFile = new StreamReader(FileName);
                string Line = JeopardyFile.ReadLine();
                if (!(Line == null))
                {
                    do
                    {
                        //ADD TOPICS
                        JTopic newtopic = new JTopic();
                        newtopic.TopicName = Line;
                        //ADD Values;Questions;Answers
                        Line = JeopardyFile.ReadLine();
                        if (!(Line == null))
                        {
                            do
                            {
                                string[] LineArray = Line.Split(Convert.ToChar(";"));
                                if (LineArray.Length > 1)
                                {
                                    newtopic.Values.Add(LineArray[0].ToString());
                                    newtopic.Questions.Add(LineArray[1].ToString());
                                    newtopic.Answers.Add(LineArray[2].ToString());
                                }
                                else
                                {
                                    goto EndTopic;
                                }
                                Line = JeopardyFile.ReadLine();
                            } while (!(Line == null));
                        }
                    EndTopic: ;
                        topics.Add(newtopic);
                    } while (!(Line == null));
                }
                JeopardyFile.Close();
            }
            catch (Exception e)
            {
                Console.WriteLine("Error: opening file..." + e.Message);
                return false;
            }
            return true;
        }

        public bool OpenFile(string FileName)
        {
            try
            {
                topics.Clear();
                //Open File
                XmlDataDocument doc = new XmlDataDocument();
                doc.Load(FileName);
                XmlNode docType = doc.FirstChild;
                XmlNode rootElement = docType.NextSibling;
                string version = rootElement.Attributes.GetNamedItem("version").InnerText;
                Console.WriteLine(version);
                if (version == "1.0")
                {
                    XmlNodeList topicElements = rootElement.ChildNodes;

                    for (int n = 0; n < topicElements.Count; n++)
                    {
                        //ADD TOPICS
                        XmlNode topicElement = topicElements[n];
                        XmlNodeList topicChildren = topicElement.ChildNodes;

                        JTopic newtopic = new JTopic();
                        for (int c = 0; c < topicChildren.Count; c++)
                        {
                            XmlNode topicChild = topicChildren[c];

                            if (topicChild.Name == "topic_name")
                            {
                                Console.WriteLine("topic_name: " + topicChild.InnerText);
                                newtopic.TopicName = topicChild.InnerText;
                            }
                            else //value
                            {
                                XmlNodeList valueElements = topicChild.ChildNodes;
                                string Value = "";
                                string Question = "";
                                string Answer = "";
                                for (int r = 0; r < valueElements.Count; r++)
                                {
                                    XmlNode valueChild = valueElements[r];
                                    switch (valueChild.Name)
                                    {
                                        case "amount":
                                            Console.WriteLine("amount: " + valueChild.InnerText);
                                            Value = valueChild.InnerText;
                                            break;
                                        case "question":
                                            Console.WriteLine("question: " + valueChild.InnerText);
                                            Question = valueChild.InnerText;
                                            break;
                                        case "answer":
                                            Console.WriteLine("answer: " + valueChild.InnerText);
                                            Answer = valueChild.InnerText;
                                            break;
                                        default:
                                            break;
                                    }
                                }
                                newtopic.Values.Add(Value);
                                newtopic.Questions.Add(Question);
                                newtopic.Answers.Add(Answer);

                            }
                        }
                        topics.Add(newtopic);
                    }
                }
            }
            catch (System.Xml.XmlException eXml)
            {
                Console.WriteLine("Error: opening file...Xml Exception: " + eXml.Message);
                if (eXml.Message.IndexOf("Data at the root level is invalid")>-1)
                {
                    //try to open the old file format
                    OpenFile_as_not_XML(FileName);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("Error: opening file..." + e.Message);

                return false;
            }
            return true;
        }


        public bool SaveJeopardy_not_as_XML(string FileName)
        {
            try
            {
                StreamWriter JeopardyFile = new StreamWriter(FileName);
                for (int t = 0; t < topics.Count; t++)
                {
                    JTopic topic = (JTopic)topics[t];
                    JeopardyFile.WriteLine(topic.TopicName);
                    for (int v = 0; v < topic.Values.Count; v++)
                    {
                        string Value = topic.Values[v].ToString();
                        string Question = "";
                        string Answer = "";
                        if (topic.Questions.Count > v)
                        {
                            Question = topic.Questions[v].ToString();
                        }
                        if (topic.Answers.Count > v)
                        {
                            Answer = topic.Answers[v].ToString();
                        }
                        JeopardyFile.WriteLine(Value + ";" + Question + ";" + Answer);
                    }
                }
                JeopardyFile.Close();
            }
            catch (Exception e)
            {
                Console.WriteLine("Error: saving file..." + e.Message);
                return false;
            }
            return true;
        }

        public bool SaveJeopardy(string FileName)
        {
            try
            {
                //Create an XmlDataDocument.
                XmlDataDocument doc = new XmlDataDocument();
                XmlProcessingInstruction instruction = doc.CreateProcessingInstruction("xml",
                        " version='1.0' encoding='UTF-8'");
                doc.AppendChild(instruction); 
                
                XmlNode rootElement = doc.CreateNode(XmlNodeType.Element, "BYOJeopardy", "");
                
                XmlAttribute version = doc.CreateAttribute("version");
                XmlText versiontext = doc.CreateTextNode("1.0");
                version.AppendChild(versiontext);
                rootElement.Attributes.Append(version);

                doc.AppendChild(rootElement);
               
                for (int t = 0; t < topics.Count; t++)
                {
                    JTopic topic = (JTopic)topics[t];
                    XmlNode topicElement = doc.CreateNode(XmlNodeType.Element, "topic", "");
                    
                    XmlNode topicnameElement = doc.CreateNode(XmlNodeType.Element, "topic_name", "");
                    XmlText topicnametext = doc.CreateTextNode(topic.TopicName);
                    topicnameElement.AppendChild(topicnametext);
                    topicElement.AppendChild(topicnameElement);


                    for (int v = 0; v < topic.Values.Count; v++)
                    {
                        string Value = topic.Values[v].ToString();
                        string Question = "";
                        string Answer = "";
                        if (topic.Questions.Count > v)
                       {
                           Question = topic.Questions[v].ToString();
                       }
                       if (topic.Answers.Count > v)
                       {
                           Answer = topic.Answers[v].ToString();
                        }
                        
                        //    XmlText topic1 = BYOJeopardyDoc.CreateTextNode("topic");
                        XmlNode valueElement = doc.CreateNode(XmlNodeType.Element, "value", "");
                                                
                        XmlNode valueAmountElement = doc.CreateNode(XmlNodeType.Element, "amount", "");
                        XmlText valuetext = doc.CreateTextNode(Value);
                        valueAmountElement.AppendChild(valuetext);
                        valueElement.AppendChild(valueAmountElement); 

                        XmlNode questionElement = doc.CreateNode(XmlNodeType.Element, "question", "");
                        XmlText questiontext = doc.CreateTextNode(Question);
                        questionElement.AppendChild(questiontext);
                        valueElement.AppendChild(questionElement);

                        XmlNode answerElement = doc.CreateNode(XmlNodeType.Element, "answer", "");
                        XmlText answertext = doc.CreateTextNode(Answer);
                        answerElement.AppendChild(answertext);
                        valueElement.AppendChild(answerElement);

                        topicElement.AppendChild(valueElement);
                    }
                    rootElement.AppendChild(topicElement);
                }
                doc.Save(FileName);
            }
            catch (Exception e)
            {
                Console.WriteLine("Error: saving file..." + e.Message);
                return false;
            }
            return true;
        }

        public void CreateJeopardy(bool Double)
        {
            int cashValue = 100;
            if (Double)
            {
                cashValue = 200;
            }

            topics.Clear();
            for (int t = 1; t < 6; t++)
            {
                JTopic topic = new JTopic();
                topic.TopicName = "Topic" + t.ToString();
                for (int v = 1; v < 6; v++)
                {
                    topic.Values.Add((v * cashValue).ToString());
                    topic.Questions.Add("Question" + (v * cashValue).ToString());
                    topic.Answers.Add("Answer" + (v * cashValue).ToString());
                }
                topics.Add(topic);
            }
            JTopic daily_double = new JTopic();
            daily_double.TopicName = "Daily Double";
            daily_double.Values.Add("Daily Topic");
            daily_double.Questions.Add("Daily Question");
            daily_double.Answers.Add("Daily Answer");
            topics.Add(daily_double);
        }
    }
    public class JTopic
    {
        public string TopicName = "";
        public ArrayList Values = new ArrayList();
        public ArrayList Questions = new ArrayList();
        public ArrayList Answers = new ArrayList();
    }
}
